#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/TEA5767/TEA5767.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 16 "C:/Users/Usuario/Documents/MikroC_pro_avr/TEA5767/TEA5767.c"
sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;

sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;


float Freq=98.9;
long Frec = 989;
short int e0=1, e1=1;

void set_up() {

DDC4_bit=0;
DDC5_bit=0;
DDB0_bit=0;
DDB1_bit=0;
TWI_Init(100000);
Delay_ms(200);
Lcd_Init();
Lcd_Cmd(_LCD_CLEAR);
Lcd_Cmd(_LCD_CURSOR_OFF);
Lcd_Out(1, 2, "RADIO_FM");
Lcd_Out(2, 10, "MHZ");
Delay_ms(10);

}

void Write_Frequency(double frequency)
{
 unsigned char frequencyH=0;
 unsigned char frequencyL=0;
 unsigned int frequencyB;

 frequencyB=4*(frequency*1000000+225000)/32768;
 frequencyH=frequencyB>>8;
 frequencyL=frequencyB&0XFF;

 TWI_Start();
 TWI_Write( 0xC0 );
 TWI_Write(frequencyH);
 TWI_Write(frequencyL);
 TWI_Write(0xB0);
 TWI_Write(0x10);
 TWI_Write(0x00);
 TWI_Stop();
 Delay_ms(10);
}
void Print_FM(long FM) {

 unsigned char ch ;

 if(FM<1000) {
 Lcd_Chr(2,4,' ');
 ch = (FM / 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = (FM /10)% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,7,'.');
 ch = FM % 10;
 Lcd_Chr(2,8,48+ch);
 }
 else {
 ch = FM/1000;
 Lcd_Chr(2,4,48+ch);
 ch = (FM / 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = (FM /10)% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,7,'.');
 ch = FM % 10;
 Lcd_Chr(2,8,48+ch);
 }
 Delay_ms(10);
}
void main() {
 set_up();
 Write_Frequency(Freq);
 Print_FM(Frec);
 do {
 if (Button(&PINB,0,10,0)) e0=0;
 if (e0==0 && Button(&PINB,0,10,1)){
 Freq=Freq-0.1;
 Frec=Frec--;
 if (Freq<88.0) Freq=108.0;
 if (Frec<880) Freq=1080;
 Write_Frequency(Freq);
 Print_FM(Frec);
 e0=1;
 }
 if (Button(&PINB,1,10,0)) e1=0;
 if (e1==0 && Button(&PINB,1,10,1)){
 Freq=Freq+0.1;
 Frec=Frec++;
 if (Freq>108.0) Freq=88.0;
 if (Frec>1080) Frec=880;
 Write_Frequency(Freq);
 Print_FM(Frec);
 e1=1;
 }
 } while (1);
}
